#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
        // other functions declared here
	CONCEPT_DLL_API CONCEPT_md5 CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_sha1 CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_crc32 CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__aes_encrypt CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__aes_decrypt CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__rsa_encrypt CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__rsa_decrypt CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__rsa_generate_keys CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__rsa_sign CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__rsa_verify CONCEPT_API_PARAMETERS;

	CONCEPT_FUNCTION(hmac_md5)
	CONCEPT_FUNCTION(hmac_sha1)
    CONCEPT_FUNCTION(hmac_sha256)
}


#endif // __LIBRARY_H
